\section{Real algebraic numbers}\label{sec:preliminaries:ran}

When computing with numbers in an exact way, we usually think of integers, rationals, or reals.
While there are decent libraries for arbitrarily large integers and rationals, for example~\cite{Granlund}, we should not expect to deal with the real numbers in a similarly constructive way.

One common approach is to trade in provable correctness (by computing with an exact representation) for efficiency by using floating-point numbers that usually come with hardware support following~\cite{IEEE754}.
Throughout this thesis, and when provable correctness is strictly required, this is oftentimes not sufficient as this floating-point representation comes with a limited precision that may introduce rounding errors. Furthermore, practical experience shows that these rounding errors accumulate to be significant during the computation and we thus need some exact way to represent and compute with real numbers.

It is possible to exploit the performance of floating-point numbers by representing a real number by an interval that contains it and ensure that all operations on this interval are \emph{over-approximating}. This is common for certain applications, for example in \emph{interval constraint propagation} (ICP), and efficient implementations of such intervals exist that take care of appropriate rounding, for example, Boost interval~\cite{Boost}. 
They work well if the intervals can be refined regularly -- either because this is how the method works anyway, like for ICP, or because we have additional \emph{symbolic} information -- but otherwise tend to accumulate rounding errors.

Fortunately, we do not require the full set of real numbers in this work because the ways how numbers ``emerge'' in our scenario are limited.
As our input is always finite, numbers can (exactly) be represented as rationals. We then compute with these numbers using what ultimately are only basic arithmetic operations most of the time. The only exception is when we compute the real roots of polynomials (over the rationals) by real root isolation as presented in the previous section.
The set of such roots (of polynomials over the rationals) is called the \emph{real algebraic numbers} and covers all reals except for the \emph{transcendental} numbers -- like $\pi$ or Euler's number $e$.

\begin{definition}{Real algebraic numbers}{real-algebraic-number}\silentdefindex{real-algebraic-number}
	Let $\alpha \in \R$ be a real number. We call $\alpha$ a \defindex{real-algebraic-number} if there is a polynomial $0 \neq p \in \Q[\xi]$ with $p(\alpha) = 0$.
	We denote the set of all \indexpl{real-algebraic-number} by $\Rat$ and note that $\Q \subsetneq \Rat \subsetneq \R$.
\end{definition}

We are commonly used to \emph{explicit numeric} representations for integers, typically in binary, and rationals -- given by explicit numerators and denominators. Therefore, we usually make no conceptual difference between the meaning of a number and its representation.
Though representations like $\sqrt{2}$ might suggest that it is just as easy for real algebraic numbers, there oftentimes is no (finite) \emph{explicit numeric} representation, but only a \emph{symbolic declarative} one.
We thus recognize that we can not \emph{just compute} with real algebraic numbers. Though they are (almost) seamlessly integrated within software packages like Maple or Mathematica, dealing with real algebraic numbers requires a significant amount of algebraic machinery in the background.

At this point, we have two possibilities: we can consider real algebraic numbers an implementation detail and assume our environment to ``just support'' them, for example, if we use a full-fledged computer algebra system like Maple, Mathematica, or alike. If this is the case, the reader may want to skip to the end of this section.
The presented implementation, however, did not take place within such a system -- for various reasons -- and the proper implementation of real algebraic numbers was a major concern.

Consider for example $\sqrt{2}$ where it is well-known that the sequence of decimal places is infinite and non-repeating. We have a concise symbolic representation -- commonly written $\sqrt{2}$ -- which only bears little information on how to work with this number, though. Can we easily determine whether we have some $q \in \Q$ such that $q \cdot \sqrt{2} = \sqrt{8}$? Can we still do the same for $\sqrt{3 + \sqrt{3}}$ and $\sqrt{3 - \sqrt{3}}$?

To resolve these issues, we introduce a representation for real algebraic numbers that is both \emph{symbolic} and \emph{numeric}, allowing us to work both symbolically and numerically, whatever is suitable or more efficient for the desired operation.
The symbolic part is a polynomial with one root being the represented number while the numeric part is an interval containing exactly one of the roots of the polynomial.
Though alternative representations exist as well, and we mention them briefly in \cref{ssec:preliminaries:ran:other-representations}, we consider this ``the'' representation of a real algebraic number for the purpose of this thesis.

\begin{definition}{Representation of real algebraic numbers}{ran:representation}\silentdefindex{ran:representation}
	Let $\alpha \in \Rat$, $0 \neq p \in \Q[\xi]$, and $I$ be a real interval that is either open ($I = (\BoundL{\alpha}, \BoundU{\alpha}) \subseteq \R$) or a point interval ($I = [\alpha,\alpha]$). We say that $(p,I)$ \emph{represents} the real algebraic number $\alpha$ if $\Roots(p) \cap I = \{ \alpha \}$.
	In this case, we call $p$ a \emph{polynomial of $\alpha$} and $I$ an \emph{isolating interval of $\alpha$}.
\end{definition}

Note that we oftentimes \emph{identify} $\alpha$ with $(p,I)$ and thus say that $(p,I)$ \emph{is} a real algebraic number, though neither the polynomial nor the interval is unique for a real algebraic number $\alpha$.
Although this is not strictly necessary, we usually make sure that $p$ is \emph{irreducible} and \emph{normalized}, making it the \emph{minimal polynomial} of $\alpha$ (and thereby unique). A proper definition of these terms follows shortly in \cref{ins:preliminaries:algebraic-foundations}.

We have different options for how to store the interval endpoints, for example, floating-point numbers or arbitrary rational numbers. While the former may be much faster, it ultimately suffers from its limited precision.
We assume the interval endpoints to be rationals with arbitrary precision (which works in general as $\Q$ is dense in $\R$) and thus, the isolating interval may only be a point interval if $\alpha \in \Q$, but is necessarily an open interval if $\alpha \in \Rat \setminus \Q$.
For a point interval, we can furthermore extract the (precise) rational assignment and eventually replace the above representation by a rational to easily exploit this information in all subsequent operations.

Before we discuss the operations we need to perform on real algebraic numbers and how to implement them, we look at how we obtain them in the first place.
As already mentioned before they arise when we compute the real roots of polynomials.

\subsection{Real root isolation}\label{ssec:preliminaries:ran:real-root-isolation}

Many methods that argue about properties of polynomials -- in particular those that this thesis is concerned with -- employ one fundamental building block: they need to distinguish the different real roots of a polynomial. While some purely symbolic methods exist that we discuss later as well, it has proven to be very beneficial in practice to work with some explicit approximation of a real root, which is usually maintained as an \emph{isolating interval} that contains the real root.

\begin{definition}{Real root isolation}{real-root-isolation}\silentdefindex{real-root-isolation}
	Let $p \in \Q[x]$ be a univariate polynomial. A \emph{real root isolation of $p$} is a set that contains a single isolating interval for every real root of $p$.
\end{definition}

As an isolating interval needs to contain the real root -- and not only be a \emph{good} approximation -- standard numerical techniques for real root finding are not immediately applicable with similar arguments as discussed in \cref{ssec:introduction:incomplete:numerical}. Attempts to apply these techniques anyway can be found in~\cite{Kremer2013}, though with arguably modest success.

As numerical methods are difficult to apply -- and this problem in some form even predates modern numerical analysis methods -- it has sparked various specialized methods.
Research on this specific problem includes Descartes' rule of signs~\cite{Descartes1637} and Sturm's theorem~\cite{Sturm1829}, but also more recent ones like~\cite{Heindel1970,Collins1976,Sagraloff2012}.

They all have in common that some algebraic technique is used to count (in the case of Sturm's theorem) or at least provide an upper bound (in the case of Descartes' rule of signs) on the number of real roots within a given interval.
Given an initial interval, we can subdivide the interval until every interval contains at most a single real root.

As for the initial interval, we have methods to compute an upper bound on the (absolute) value of any real root -- for example~\cite{Cauchy1828,Fujiwara1916,Hirst1997} or~\cite{Lagrange1808,Mignotte2002}. If any of those yields an upper bound $a$, then we can perform such a bisection approach with the initial interval $[-a,a]$ and obtain isolating intervals for all real roots.
An abstract algorithm that employs these building blocks -- and may very well be extended with various optimizations -- is sketched in \cref{algo:real-root-isolation}.

\begin{algorithm}
	\caption{Abstract real root isolation algorithm}\label{algo:real-root-isolation}
	
	\SetKwFunction{RealRootIsolation}{RealRootIsolation}
	\Fn{\RealRootIsolation{$p$}}{
		$R \coloneqq \emptyset$ \;
		$Q \coloneqq \{ $ initial interval based on some root bound $\}$ \;
		\While{$Q \neq \emptyset$}{
			$I \coloneqq $ remove some element from $Q$ \;
			\If{$I$ contains no root of $p$}{
				Drop $I$ \;
			}\ElseIf{$I$ contains a single root of $p$}{
				$R \coloneqq R \cup \{ I \}$ \;
			}\Else{
				Split $I$ into disjoint intervals $I_1, I_2, \dots$ with $I = \DisjointUnion_i I_i$\;
				$Q \coloneqq Q \cup \{I_1, I_2, \dots \}$ \;
			}
		}
		\Return{$R$}
	}
\end{algorithm}

While the correctness immediately follows from the ability to correctly compute an initial interval and safely answer the question whether the interval has no or only a single real root, termination can be a bit more involved if we can not exactly count the number of real roots -- as is the case for Descartes' rule of signs that only yields an upper bound.
We refer to the literature already cited above for details on this topic.
Furthermore, we need to employ a sensible splitting heuristic, for example, we should only split into finitely many intervals and not allow for infinitesimally small intervals.

Note that we oftentimes need to take special care of the interval endpoints, as the methods to \emph{count} the real roots within an interval usually only work in \emph{open intervals}.
Therefore, we split intervals into open intervals and point intervals, where point intervals can be processed by simply evaluating the polynomial on this (rational) point.

\subsection{Algebraic foundations}

Before we go into the algorithmic details on how to work with real algebraic numbers, let us make a turn and lay some algebraic groundwork here, in particular minimal polynomials and the correspondence of field extensions and quotient rings.
The main question that we target here is how we can (partially) evaluate a multivariate polynomial over real algebraic numbers.
The following discussion is mostly taken from~\cite{Artin1991} and we refer the reader to~\cite{Artin1991}, or any other textbook on algebra, for proper definitions.
We summarize the key insights below and expect these to be sufficient to understand the subsequent discussion.

\begin{insertion}{Algebraic foundations~\cite{Artin1991}}{preliminaries:algebraic-foundations}
	Let $K$ be a field and $\alpha$ an algebraic number over $K$.
	We define $K(\alpha)$ as the smallest field that contains both $K$ and $\alpha$ and call it an \emph{extension field of $K$}.
	Let $\varphi_\alpha: K[\xi] \rightarrow K(\alpha)$ be the $K$-linear function that maps $\xi$ to $\alpha$.
	
	The fundamental theorem on homomorphisms provides that the quotient ring $K[\xi]/\Kern(\varphi_\alpha)$ is isomorphic to $\Image(\varphi_\alpha) = K(\alpha)$ as a ring, and as $K(\alpha)$ is a field, $K[\xi]/\Kern(\varphi_\alpha)$ is a field as well.
	As $K[\xi]$ is a polynomial ring over a field, and thus a principal ideal domain, the kernel of $\varphi_\alpha$ is generated by a single element and we write $K[\xi]/\Kern(\varphi_\alpha) = K[\xi]/\langle p_\alpha \rangle$.
	The generating element of $\Kern(\varphi_\alpha) = \langle p_\alpha \rangle $ is unique (up to normalization with respect to $K$) and we call it the \emph{minimal polynomial of $\alpha$ over $K$}.
	
	Let $\alpha$ and $\beta$ be two real algebraic numbers with $p_\alpha = p_\beta$. Then we have $K(\alpha) \cong K[\xi]/\langle p_\alpha \rangle = K[\xi]/\langle p_\beta \rangle \cong K(\beta)$, however we may very well have $K(\alpha) \neq K(\beta)$, for example, $\beta \not\in K(\alpha)$ and $\alpha \not\in K(\beta)$.

	We can iterate this construction of extension fields and the corresponding quotient rings by using $K(\alpha_1)$ and $K[\xi_1]/\langle p_{\alpha_1} \rangle$ as base fields to obtain $K(\alpha_1)(\alpha_2)$ and $(K[\xi_1]/\langle p_{\alpha_1} \rangle)[\xi_2]/\langle p_{\alpha_2} \rangle$. However, $p_{\alpha_2}$ needs to be a minimal polynomial \emph{over $K(\alpha_1)$}.
	If $p_{\alpha_2}$ is reducible over $K(\alpha_1)$, $(K[\xi_1]/\langle p_{\alpha_1} \rangle)[\xi_2]/\langle p_{\alpha_2} \rangle$ is no longer an integral domain (and thus not a field) and not isomorphic to $K(\alpha_1)(\alpha_2)$.

	The extension fields we construct are (in general) neither \emph{splitting fields}, \emph{normal}, nor \emph{Galois extensions} as the minimal polynomial $p_\alpha$ may very well have another root $\beta \not\in K(\alpha)$ and thus may not decompose into linear factors over $K(\alpha)$.
	This is (in some way) already implied by the fact that we only care about \emph{real} algebraic numbers and never consider complex roots.

	For $K' = K[x]/\langle p \rangle$ we call $id_{K'}: K[x] \rightarrow K', q \mapsto q + \langle p \rangle$ the \emph{canonical embedding homomorphism}. We also write $id_{K'}$ for $id_{K'[\overline{y}]}: K[x][\overline{y}] \rightarrow K'[\overline{y}]$.
	Furthermore, we identify any $p + \langle p_\alpha \rangle \in K[\xi]/\langle p_\alpha \rangle$ with its canonical representative $p$ as given by its preimage under the following bijection:
	\[ \varphi: \{ p \in K[\xi] \mid \Degree(p) < \Degree(p_\alpha) \} \rightarrow K[\xi]/\langle p_\alpha \rangle, p \mapsto p + \langle p_\alpha \rangle \]
\end{insertion}

Let us briefly reiterate the key insights in an intuitive way.
The \emph{substitution ring homomorphism} $\varphi_\alpha$ substitutes a real algebraic number -- represented by its minimal polynomial -- for a variable into a polynomial.
The result is a polynomial over an \emph{extension field} of $\Q$ with the real algebraic numbers that we need to represent the result of the substitution.
Such an extension field is \emph{isomorphic} (``essentially identical'') to a \emph{quotient ring} and we can use the canonical representative of an element of this quotient ring instead of an element of the extension field.

Substituting a real algebraic number for a variable into a polynomial can now be done with the \emph{(canonical) embedding homomorphism} with respect to the minimal polynomials of a \emph{tower of field extensions}.

We feel that it is important to point out the intricacies of the ``identity'' of an extension field.
While an (extension) field is usually seen as the set of its elements (numbers) it contains, we oftentimes distinguish between different \emph{representations} of the same set. Though $\Q(\sqrt{2})$ and $\Q(-\sqrt{2})$ contain the same numbers -- and are thus the same -- their representations may differ, affecting practical computations with these objects.

Our common representation for an extension field $K(\alpha)$ is a quotient ring of the form $K[\xi]/\langle p_\alpha \rangle$ where $p_\alpha$ is the minimal polynomial of $\alpha$ over $K$. Such a quotient ring is isomorphic to all extension fields $K(\alpha_i)$ where $\alpha_i$ are the roots of $p_\alpha$, $\alpha$ being one of them. Note that all these extension fields are isomorphic, but not (necessarily) the same: they may very well contain different elements as we show in \cref{ex:algebraic-cancellation-unrelated-extension-field}.

In the following we oftentimes \emph{identify} an extension field $K(\alpha)$ with the corresponding quotient ring $K[\xi]/\langle p_\alpha \rangle$, acknowledging the aforementioned ambiguities.
We always use this formalism with respect to a model, and thus we can resolve these ambiguities and obtain the ``correct'' extension field by numeric evaluation with the model for the variables we use to construct the quotient ring.
For example, we do this when selecting the appropriate factor $f$ from the factorization of $p_x$ in \cref{algo:ran:algebraic-cancellation}.
Being fully aware of this issue, we nevertheless call such a quotient ring an \emph{extension field} as well, provided that we have the model at hand.

It is important to realize that the \emph{substitution homomorphism} does not actually substitute a real algebraic number -- in the numeric sense -- but only the \emph{algebraic information}. In particular, it does not (and can not) distinguish between the different roots of the minimal polynomial. Furthermore, it does not really ``get rid of the variable'' but ``only'' exploits the algebraic information from the minimal polynomial.
We thus split the task of ``evaluating a polynomial'' into three separate steps that can roughly be described as ``algebraic cancellation'', ``algebraic substitution'' and ``numeric evaluation'' where the substitution homomorphism is responsible for most of the algebraic cancellation. Before discussing these individual steps, we briefly summarize our task more formally.

\begin{definition}{(Partial) evaluation of a polynomial}{ran:task-evaluation}\silentdefindex{ran:partial-evaluation}
	Let $p \in \Q[x_1, \dots, x_n]$ and $\A = \{x_1 \mapsto \alpha_1, \dots, x_{n-1} \mapsto \alpha_{n-1} \}$.
	The result of \emph{(partially) evaluating $p$ over $\A$} shall be a polynomial $q \in \Q[x_n]$ such that $\Roots(p) \subseteq \Roots(q) \times \R^{n-1}$.

	We perform this evaluation in two steps:
	\begin{enumerate*}
		\item \emph{algebraic cancellation} makes sure that all cancellation over $\A$ is done and thus no terms of $p$ vanish anymore and
		\item \emph{algebraic substitution} reduces the resulting polynomial from $\Q[\overline{x}]$ to an appropriate polynomial in the remaining variables.
	\end{enumerate*}
\end{definition}

The resulting polynomial is then used to either evaluate a constraint or isolate its real roots. In both cases, we employ \emph{numeric evaluation}, either to perform the evaluation with the sign condition or to identify the roots of $q$ that actually correspond to roots of $p$ and discard all others.
We now present what we call \emph{algebraic cancellation} and \emph{algebraic substitution} and leave the \emph{numeric evaluation} for later as it depends on what we need to do with the resulting polynomial $q$.

\subsubsection{Algebraic cancellation}

We can understand ``algebraic cancellation'' as turning \emph{numeric cancellation} -- terms are zero under numeric evaluation with some assignment -- into \emph{symbolic cancellation} -- terms are zero under syntactic rewriting.
Indeed, the latter steps require that \emph{any possible cancellation} is done symbolically.
Let us assume we want to substitute $\sqrt{2}$ into $x^3 - x^2 + x - 1$.
If computing manually, we would proceed roughly as follows:
\[
	\underbrace{\sqrt{2}^3}_{= 2 \sqrt{2}} - \underbrace{\sqrt{2}^2}_{= 2} + \sqrt{2} - 1
	= 2 \sqrt{2} - 2 + \sqrt{2} - 1
	= 3 \sqrt{2} - 3
\]
We can not further process this expression symbolically and would start some numeric approximation now. 
Instead we can identify $x^2-2$ as the minimal polynomial of $\sqrt{2}$ over $\Q$ and \emph{embed} the polynomial into $\Q(\sqrt{2})$, or rather $\Q[x] / \langle x^2 - 2\rangle$, obtaining
\[
	(x^3 - x^2 + x - 1) + \langle x^2 - 2 \rangle = (3x - 3) + \langle x^2 - 2 \rangle
\]
in $\Q[x]/\langle x^2-2 \rangle$.
Note that the result in both variants still contains some expression that we can not immediately deal with (either $\sqrt{2}$ or $x$), however, we stay within the realm of polynomials over rational coefficients for the latter.

In case we need to substitute multiple real algebraic numbers, we can iterate this process, but need to honor a small detail here: the minimal polynomial $p_{\alpha}$ is a minimal polynomial over $\Q$, and to properly construct the quotient ring we need to obtain an appropriate minimal polynomial over the quotient ring $\Q^*$ constructed from the preceding real algebraic numbers.
We thus need to take the minimal polynomial of the next real algebraic number over $\Q$ and \emph{reduce} it with respect to $\Q^*$ as described in \cref{lem:correctness-algebraic-cancellation} and exploited in the subsequent \cref{algo:ran:algebraic-cancellation}.

\begin{lemma}{Minimal polynomial over an extension field}{correctness-algebraic-cancellation}
	Let $\Q^*$ be an extension field of $\Q$ and $p$ be the minimal polynomial of $\alpha$ over $\Q$.
	The minimal polynomial $p^*$ of $\alpha$ over $\Q^*$ is a unique element from the irreducible normalized factors of $p$ over $\Q^*$ and we have $\Q^*[\xi]/\langle p^* \rangle \cong \Q^*(\alpha)$.
\end{lemma}

\begin{proof}
	As $\alpha$ is an algebraic number, a \emph{minimal polynomial} for $\alpha$ exists over $\Q$ and every extension field of $\Q$.
	Let $\varphi$ and $\varphi^*$ be the $\Q$-linear ring homomorphisms for $\Q$ and $\Q^*$ for $\alpha$ as follows:

	\[
	\begin{tabular}{rrlrl}
		$\varphi:$ & $\Q[\xi]$ & $\rightarrow$ & $\Q(\alpha)$, & $\xi \mapsto \alpha_x$ \\
		$\varphi^*:$ & $\Q^*[\xi]$ & $\rightarrow$ & $\Q^*(\alpha)$, & $\xi \mapsto \alpha_x$
	\end{tabular}
	\]

	Let $p^*$ be the minimal polynomial of $\alpha$ over $\Q^*$. As $\varphi = \varphi^*\restrict{\Q[\xi]}$, we have
	\[
		p \in \Kern(\varphi) = \Kern(\varphi^*\restrict{\Q[\xi]}) \subseteq \Kern(\varphi^*) = \langle p^* \rangle
	\]
	and thus $p^*$ divides $p$.
	Hence, we find the minimal polynomial of $\alpha$ over $\Q^*$ by considering all the irreducible normalized factors of $p$ over $\Q^*$.
	Finally, we construct $\Q^*[\xi]/\langle p^* \rangle$, which is isomorphic to $\Q^*(\alpha)$, using the embedding homomorphism as $p^*$ is the minimal polynomial of $\alpha$ over the base field $\Q^*$.
\end{proof}

In \cref{algo:ran:algebraic-cancellation}, we need to construct a minimal polynomial for $\alpha_x$ over $\Q^*$ from the minimal polynomial $p_x$ over $\Q$.
Following \cref{lem:correctness-algebraic-cancellation}, we consider all irreducible and normalized factors of $p_x$ over $\Q^*$ and select the one that vanishes over $\alpha_x$.
Due to \cref{lem:correctness-algebraic-cancellation}, this factor $f$ exists and is unique.
Finally, we use this minimal polynomial $f$ over $\Q^*$ to construct the new extension field.

\begin{algorithm}
	\caption{Perform algebraic cancellation}\label{algo:ran:algebraic-cancellation}

	\SetKwFunction{AlgebraicCancellation}{AlgebraicCancellation}
	\KwIn{polynomial $p$, model $\A$}
	\Fn{\AlgebraicCancellation{$p$, $\A$}}{
		$\Q^* \coloneqq \Q$, $\A^* \coloneqq \emptyset$ \;
		\For{$x \mapsto \alpha_x \in \A$}{
			Let $p_x$ the minimal polynomial of $\alpha_x$ \Comment*[r]{$p_x$ in variable $\xi_x$}
			Let $f \in \Factors(p_x, \Q^*[\xi_x])$ such that $f(\A^*, \xi_x \mapsto \alpha_x) = 0$ \;
			\If{$f$ is linear in $\xi_x$}{
				Substitute $\xi_x - f$ for $x$ in $p$ \;
			}
			\Else{
				\nllabel{algo:ran:algebraic-cancellation:qprime} Let $\Q^* \coloneqq \Q^*[\xi_x]/\langle f \rangle$ \;
				Let $\A^* \coloneqq \A^* \cup \{ \xi_x \mapsto \alpha_x \}$ \;
			}
		}
		\Return{$id_{\Q^*}(p)$}
	}
\end{algorithm}

If the minimal polynomial over $\Q^*$ is linear in $\xi_x$, then already $\alpha \in \Q^*$ and we can simplify this procedure by directly replacing $x$ in $p$ instead of making the effort to construct another quotient ring and keeping an additional variable (though this would still be correct).
We finally embed $p$ into $\Q^*$ to obtain the properly reduced polynomial and rest the correctness of \cref{algo:ran:algebraic-cancellation} on \cref{lem:correctness-algebraic-cancellation}.

We concede that it may not be immediately clear intuitively why the reduction from \cref{algo:ran:algebraic-cancellation} is necessary.
Let us thus work through a few examples that illustrate how the resulting polynomial $q$ is not ``fully canceled'' if we do not reduce the minimal polynomials.
The first \cref{ex:algebraic-cancellation-same-extension-field} shows the most intuitive case, where two real algebraic numbers come from the same extension field.

\begin{example}{Same extension field}{algebraic-cancellation-same-extension-field}
	Let $\A = \{x_1 \mapsto \sqrt{2}, x_2 \mapsto \sqrt{2} \}$ and $q = x_1 + x_2$.
	Naturally, we want to realize that indeed $x_1 = x_2$ and only perform the algebraic operations once.
	Starting with $\Q^* = \Q$ and $x_1 \mapsto \sqrt{2}$, $\xi_1^2-2$ is the minimal polynomial of $\sqrt{2}$ over $\Q^*$ and we construct $\Q^* = \Q[\xi_1]/\langle \xi_1^2 - 2 \rangle$.

	For $x_2$ we have the minimal polynomial $\xi_2^2-2$ for $\sqrt{2}$ over $\Q$ which factors into $(\xi_2+\xi_1) \cdot (\xi_2 - \xi_1)$ over $\Q^*$ and we select the factor $\xi_2 - \xi_1$ as the minimal polynomial of $\sqrt{2}$ over $\Q^*$ (as the corresponding polynomial factor $x_2 - x_1$ vanishes over $\A$).
	We can recognize that this is \emph{linear in $\xi_2$} and instead of constructing another quotient ring simply eliminate $x_2$ using $x_2 \coloneqq x_1$.

	This is not unique to identical real algebraic numbers, but for all that can directly be represented within the current extension field $\Q^*$.
	Consider for example $x_2 \mapsto 5$ or $x_2 \mapsto 1 + \sqrt{2}$ which can also be dealt with in this way.
	We can understand this as \emph{finding a linear parametrization in the previous assignments}.
\end{example}

\begin{minipage}{0.78\textwidth}
	Let us consider a slightly more complex and arguably less intuitive case.
	Assume the extension field of a real algebraic number to be \emph{related} to the current $\Q^*$ in the sense that it has a nontrivial intersection (more than $\Q$) but is not included in $\Q^*$ as depicted on the right.
	In this case, the minimal polynomial factors into multiple factors, but the vanishing factor $f$ is not linear.
\end{minipage}\hfill{}
\begin{minipage}{0.2\textwidth}
	\centering
	\tikzexternaldisable
	\begin{tikzpicture}
		\node (Q1) at (0,0) {$\Q$};
		\node (Q2) at (0,1) {$\Q\left(\sqrt{2}\right)$};
		\node (Q3) at (0,2) {$\Q\left(\sqrt[4]{2}\right)$};
		\path (Q1) edge[subset] (Q2);
		\path (Q2) edge[subset] (Q3);
	\end{tikzpicture}
	\tikzexternalenable
\end{minipage}


\begin{example}[reset and store to box array, title after break={\cref{ex:algebraic-cancellation-related-extension-field} continued}]{Related extension field}{algebraic-cancellation-related-extension-field}
	Let $\A = \{ x_1 \mapsto \sqrt{2}, x_2 \mapsto \sqrt[4]{2} \}$ with $p_1 = \xi_1^2-2$ and $p_2 = \xi_2^4-2$ the minimal polynomials of $\sqrt{2}$ and $\sqrt[4]{2}$ over $\Q$.
	We observe, that $p_2$ factors into $(\xi_2^2-\xi_1) \cdot (\xi_2^2+\xi_1)$ over $\Q[\xi_1]/\langle p_1 \rangle$, but ignore this knowledge for the moment and attempt to extend $\Q^*$ with the original $p_2$.

	Assume $a = \xi_2^2-\xi_1$, $b = \xi_2^2+\xi_1$ and $c = 0$, then we have $a \cdot b = 0 = a \cdot c$ and $a \neq 0$ in $(\Q[\xi_1]/\langle p_1 \rangle)[\xi_2]/\langle p_2 \rangle$, but $b \neq c$.
	This violates the definition for \emph{integral domains} and thus $(\Q[\xi_1]/\langle p_1 \rangle)[\xi_2]/\langle p_2 \rangle$ is not a field.

	\tcbbreak

	Let $p = (x_2^2 - x_1) \cdot x_3$. 
	Embedding $p$ into $(\Q[\xi_1]/\langle p_1 \rangle)[\xi_2]/\langle p_2 \rangle$ --- which is not even an integral domain as shown before -- yields $(\xi_2^2 - \xi_1) \cdot x_3$, though $p$ vanishes identically at $\A$.
	The factorization of $p_2$ over $\Q[\xi_1]/\langle p_1 \rangle$ instead gives us $(\xi_2^2-\xi_1) \cdot (\xi_2^2+\xi_1)$ and we construct $\Q^* = (\Q[\xi_1]/\langle p_1 \rangle)[\xi_2]/\langle \xi_2^2-\xi_1 \rangle$. Embedding $p$ into $\Q^*$ now correctly yields $p = 0$.

	\tcbbreak

	Let instead $\A = \{ x_1 \mapsto \sqrt[4]{2}, x_2 \mapsto \sqrt{2} \}$.
	Then $p_2$ factors into $(\xi_1^2-\xi_2) \cdot (\xi_1^2+\xi_2)$ over $\Q[\xi_1]/\langle p_1 \rangle$ and we can derive that either $\xi_2 = \xi_1^2$ or $\xi_2 = -\xi_1^2$.
	This allows us to avoid constructing another quotient ring altogether and simply substitute $\xi_2$ (by either $\xi_1^2$ or $-\xi_1^2$) in $p$.
\end{example}

\useboxarray{1}

It might not be immediately clear why working on a $\Q^*$ that is not a field like shown in \cref{ex:algebraic-cancellation-related-extension-field} should be a problem.
Of course, fields are a ``more convenient'' structure in general, but we show now that the algebraic cancellation may indeed fail.

\useboxarray{2}

We used two real algebraic numbers that have an algebraic relation (namely $\alpha_1 = \alpha_2^2$) and we see that cancellation is only performed incompletely if the information about this relation is not explicitly stated.
Also note that this process heavily depends on the order in which the real algebraic numbers are considered as we see next.

\useboxarray{3}

\begin{minipage}{0.73\textwidth}
	In the previous example we considered \emph{related} real algebraic numbers -- in the sense that $\alpha_1 \in \Q(\alpha_2)$ -- with different minimal polynomials.
	It is also possible that two \emph{unrelated} real algebraic numbers have the same minimal polynomial as we see in \cref{ex:algebraic-cancellation-unrelated-extension-field}.
	Note that, as depicted on the right, the extensions field for these \emph{unrelated} real algebraic numbers are still \emph{isomorphic}.
\end{minipage}\hfill{}
\begin{minipage}{0.25\textwidth}
	\centering
	\tikzexternaldisable
	\begin{tikzpicture}
		\node (Q1) at (0,0) {$\Q$};
		\node (Q2) at (-0.75,1) {$\Q(\alpha_1)$};
		\node (Q3) at (0.75,1) {$\Q(\alpha_2)$};
		\node (Q4) at (0,2) {$\Q(\alpha_1,\alpha_2)$};
		\path (Q1) edge[subset] (Q2);
		\path (Q1) edge[subset] (Q3);
		\path (Q2) edge[subset] (Q4);
		\path (Q3) edge[subset] (Q4);
		\path (Q2) edge[isomorph] (Q3);
	\end{tikzpicture}
	\tikzexternalenable
\end{minipage}

\begin{example}[reset and store to box array, title after break={\cref{ex:algebraic-cancellation-unrelated-extension-field} continued}]{Unrelated extension field}{algebraic-cancellation-unrelated-extension-field}
	Let $p = \xi^4 - 6 \xi^2 + 6$ be \emph{irreducible over $\Q[\xi]$} with four real roots $\alpha_{1,2} = \pm\sqrt{3 + \sqrt{3}}$ and $\alpha_{3,4} = \pm\sqrt{3 - \sqrt{3}}$.
	We can show that $\alpha_3 \not\in \Q(\alpha_1)$ and $\alpha_1 \not\in \Q(\alpha_3)$ and thus $\Q[\xi]/\langle p \rangle$ represents two different -- though isomorphic -- extension fields.

	\tcbbreak

	Assume $K_1 = \Q[\xi_1]/\langle \xi_1^4 - 6 \xi_1^2 + 6 \rangle$. $p$ is not irreducible over $K_1$ but factors into $(\xi + \xi_1) \cdot (\xi - \xi_1) \cdot (\xi^2 + \xi_1 - 6)$ and we can construct a second extension field $K_2 = (\Q[\xi_1]/\langle \xi_1^4 - 6 \xi_1^2 + 6 \rangle)[\xi_2]/\langle \xi_2^2 + \xi_1 - 6 \rangle$.
\end{example}

\useboxarray{1}

\begin{minipage}{0.68\textwidth}
	If we indeed want to work with all of these roots, for example $\alpha_1$ and $\alpha_3$, we have to construct further extension fields -- one for each group of what one could call ``adjoint'' roots -- until all of the roots are contained in $\Q^*$.
	For this to work, we compute the minimal polynomial of $\alpha_3$ in $\Q(\alpha_1)$ as shown in the continued example.
	Consider the visualization on the right on how these fields relate to each other.
\end{minipage}\hfill{}
\begin{minipage}{0.3\textwidth}
	\centering
	\tikzexternaldisable
	\begin{tikzpicture}
		\node (Q1) at (0,0) {$\Q$};
		\node (Q2) at (-1.25,1) {$\Q(\alpha_1)$};
		\node (Q3) at (1.25,1) {$\Q(\alpha_3)$};
		\node (Q4) at (0,2) {$\Q(\alpha_1,\alpha_3)$};
		\node (K1) at (0,1) {$K_1$};
		\node (K2) at (-1.5,2) {$K_2$};
		\path (Q1) edge[subset] (Q2);
		\path (Q1) edge[subset] (Q3);
		\path (Q2) edge[subset] (Q4);
		\path (Q3) edge[subset] (Q4);
		\path (Q2) edge[isomorph] (K1);
		\path (K1) edge[isomorph] (Q3);
		\path (K2) edge[isomorph] (Q4);
	\end{tikzpicture}
	\tikzexternalenable
\end{minipage}

\useboxarray{2}

\subsubsection{Algebraic substitution}

Now that we have taken care of all cancellations, we need to eliminate the respective variables from the polynomial. Let us first discuss possible implementations and then consider an example.
We propose two versions, either based on Gröbner bases or resultants, which both allow projecting algebraic information about the roots of polynomials onto lower dimensions.
Note that we sometimes speak about ``eliminating variables'' here, fully aware that this is, in fact, different from \emph{quantifier elimination} and more similar to how a projection operator in the cylindrical algebraic decomposition ``eliminates variables''.

The fundamental insight for both variants is to understand the problem of substitution as a system of equalities, consisting of the input polynomial $p$ (embedded into the extension field) and the minimal polynomials $m_i$ (of the extension fields).
To obtain the polynomial $q$ we need to eliminate $x_1, \dots x_k$ from this system of equalities.

One of the most popular methods in computer algebra in general are Gröbner bases.
We refrain from a definition or an in-depth discussion here and only refer to appropriate literature like the one referenced in \cref{ssec:introduction:incomplete:groebner}.
In particular, however, Gröbner bases can be instrumented to perform exactly this kind of ``variable elimination'' by employing an appropriate \emph{elimination order}.
In our case we use the canonical variable order $x_1 < \cdots < x_n$ -- or rather the induced lexicographical term order.

Under this lexicographical order (which is an \emph{elimination order}) the resulting Gröbner basis always contains a polynomial $q$ from $\Q[x_n]$ and the roots of this polynomial cover the roots of the input polynomial $p$ over the given assignment. We formalize this statement in the following \cref{thm:gbasis-for-algebraic-substitution} and note that we only consider the special case of $k = n-1$ here. For arbitrary $k$ this works essentially the same, however, we only require $k = n-1$ for the subsequent operations.

\begin{theorem}{Gröbner basis for algebraic substitution}{gbasis-for-algebraic-substitution}\silentindex{groebner-bases}
	Let $p \in \Q[x_1, \dots, x_n]$ be a polynomial, $\A = \{x_1 \mapsto \alpha_1, \dots, x_{n-1} \mapsto \alpha_{n-1} \}$ an assignment, and $p_i$ minimal polynomials for $\alpha_i$ over $\Q[x_1, \dots, x_i]/\langle p_1, \dots, p_{i-1}\rangle$ as constructed in \cref{algo:ran:algebraic-cancellation}.
	
	Let $I \coloneqq \{p_1, \dots, p_{n-1}, p \}$ and let $G$ be the Gröbner basis of $I$ with an elimination block ordering $\{x_1, \dots, x_{n-1} \} > \{x_n \}$.
	Then $G$ contains at least one non-zero polynomial $q_n \in \Q[x_n]$.
	Thus, the real roots of $q_n$ (in $x_n$) cover all solutions of $G$ and as $\langle G \rangle = \langle I \rangle$ also \emph{cover all real roots of $p$ evaluated at $\A$}:
	\[
		\Roots(p(\A)) \subseteq \Roots(q_n)
	\]
\end{theorem}

\begin{proof}
	We have seen that $K \coloneqq \Q[x_1, \dots, x_{n-1}]/\langle p_1, \dots, p_{n-1}\rangle$ is a field and its dimension over $\Q$ is finite.
	Furthermore, the leading coefficient of $p$ as polynomial from $\Q[x_1, \dots, x_n]/\langle p_1, \dots, p_{n-1}\rangle$ (or rather $K[x_n]$) is invertible and we obtain $p' = p / \Lcoeff(p) = x_n^d - \sum_{i=1}^{d-1} a_i x_n^i$ for some coefficients $a_i \in K$.
	Thus, we have $\langle I' \rangle \coloneqq \langle p_1, \dots, p_{n-1}, p'\rangle = \langle p_1, \dots, p_{n-1}, p\rangle = \langle I \rangle$.
	
	Now consider $J \coloneqq \Q[x_1, \dots ,x_n]/\langle I' \rangle$ as vector space over $\Q$.
	From $p' \in \langle I' \rangle$ we get $p'=0$ in $J$, or equivalently $x_n^d = \sum_{i=1}^{d-1} a_i x_n^i$.
	Hence, $J$ is finitely generated as vector space over $K$ by $\{ 1, x_n, x_n^2, \dots, x_n^{d-1} \}$ and, thus, has finite dimension as vector space over $\Q$.
	We claim that every (non-zero) element from this vector space $J$ is algebraic and we can use its minimal polynomial over $\Q$ to construct a polynomial in $\langle I' \rangle$.

	Let $0 \neq p \in J$ be such a non-zero element and consider the vector space over $\Q$ given by $J' \coloneqq \langle 1, p, p^2, \dots \rangle_\Q$.
	As $J$ is a $\Q$-algebra and thus closed under multiplication, $J'$ is a sub-vector space of $J$.
	$J$ has finite dimension, thereby $J'$ has finite dimension as well and thus $J' = \langle 1, p, p^1, \dots, p^{d-1} \rangle_\Q$ for some $d$.
	Hence, there exist coefficients $a_i \in \Q$ such that $p^d = \sum_{i=0}^{d-1} a_i \cdot p^i$. If $d$ is minimal, $\sum_{i=0}^{d-1} a_i \cdot p^i$ is the minimal polynomial for $p$ and in particular $p^d - \sum_{i=0}^{d-1} a_i \cdot p^i = 0$.

	This implies that $p^d - \sum_{i=0}^{d-1} a_i \cdot p^i \in \langle I' \rangle$ and for $p = x_n$ we have a polynomial $q_n \in \Q[x_n]$ such that $q_n \in \langle I' \rangle = \langle I \rangle$.

	Under an elimination block ordering of the form $\{x_1, \dots, x_{n-1} \} > \{x_n \}$, such a $q_n \in \Q[x_n]$ is one of the generators of the reduced Gröbner basis of $\langle I \rangle$.
\end{proof}

\silentindex{resultant}
We can also slightly reframe the system of equalities as the search for common roots of multiple polynomials.
Resultants are commonly used to generate a polynomial with one variable less whose roots \emph{witness} the common roots of the input polynomials, which is essentially what we need here.
Note that the resultant itself argues about \emph{complex roots}, and thus not every \emph{real root} of the resultant witnesses a \emph{common real root} of the input polynomials. Instead, the real roots of the resultants \emph{cover} all common real roots of the input polynomials.

Given that we have one polynomial over $\overline{x}$ and one polynomial over every $x_i$ that shall be eliminated, we can give an easy scheme that applies resultants to compute $q$:
\[
	q_k \coloneqq p \qquad
	q_i \coloneqq \Res_{\xi_{i+1}}(q_{i+1}, p_i) \qquad
	q \coloneqq q_0
\]

Both methods -- either using a Gröbner basis with an appropriate elimination order or using iterated resultants -- yield a polynomial (equation) that is \emph{univariate in $x_n$} and \emph{logically follows} from the input equations.
Thus, the real roots for the input polynomial $p$ are a subset of the assignment $\A$ extended with the real roots of the polynomial $q$.
We show how both approaches can be used in the following \cref{ex:algebraic-substitution}.

\begin{example}{Algebraic substitution}{algebraic-substitution}
	Let $\A = \{ x_1 \mapsto \sqrt{2}, x_2 \mapsto \sqrt[4]{2} \}$ and $p = (x_2^2 + x_1) \cdot x_3$. We have seen in \cref{ex:algebraic-cancellation-related-extension-field} that we construct $\Q^* = (\Q[\xi_1]/\langle \xi_1^2-2 \rangle)[\xi_2]/\langle \xi_2^2-\xi_1 \rangle$.
	Embedding $p$ into $\Q^*$ yields $(\xi_2^2+\xi_1) \cdot x_3$.

	The Gröbner basis of $\{ \xi_1^2-2, \xi_2^2-\xi_1, (\xi_2^2+\xi_1) \cdot x_3\}$ under the elimination order $\xi_1 > \xi_2 > x_3$ is $\{\xi_1-\xi_2^2, \xi_2^4-2, x_3\}$ and we thus extract $q \coloneqq x_3$.

	Using resultants we can compute
	$q_2 = p$, $q_1 = \xi_1 \cdot x_3$ and finally $q = q_0 = x_3$ to obtain the same result.
\end{example}

Note that this algebraic substitution is not necessarily \emph{exact} (or \emph{precise}) in the sense that the resulting polynomial $q$ has \emph{exactly} the roots we are looking for. 
As the algebraic substitution only works on the minimal polynomials -- that can not distinguish between any of its real roots -- we essentially get all possible solutions for all the roots.
The resulting polynomial $q$ might thus have additional roots where $p$ does not vanish and we call such roots \emph{spurious}.

As $q$ only has finitely many roots, we can check them individually (whether $p$ vanishes over this root) and thereby identify the ``actual'' real roots of $p$ and discard the spurious roots as shown in \cref{ex:algebraic-substitution-with-spurious-roots}.

\begin{example}{Algebraic substitution with spurious roots}{algebraic-substitution-with-spurious-roots}
	Let $\A = \{ x_1 \mapsto \sqrt{2} \}$ and $p = x_2^2 + (2-x_1) \cdot x_2 + 1 - x_1$.
	We obtain $x_2^3 + 3x_2^2 + x_2 - 1$ -- either from a Gröbner basis or the (reduced) resultant -- which again factors into $(x_2+1) \cdot (x_2^2 + 2x_2 - 1)$ with real roots $-1$ and $-1 \pm \sqrt{2}$.
	We check that $\{ x_1 \mapsto \sqrt{2}, x_2 \mapsto -1 \}$ is indeed a root, as is $\{ x_1 \mapsto \sqrt{2}, x_2 \mapsto -1 + \sqrt{2} \}$.
	However, $\{ x_1 \mapsto \sqrt{2}, x_2 \mapsto -1 - \sqrt{2} \}$ is spurious as $p$ does not vanish at this point.
\end{example}

Note that evaluating a polynomial $p$ over some variable assignment is usually formulated as isolating the (unique) real root of $v - p$, where $v$ is a fresh variable.
However, this requires real root isolation over a (partial) variable assignment again and leaves us with a cyclic dependency of these two methods.
We thus show how to evaluate the constraint $p = 0$ without relying on real root isolation in the following \cref{ssec:ran:computation}.

\subsection{Computing with real algebraic numbers}\label{ssec:ran:computation}

Though we introduced real algebraic numbers as a general set of numbers -- just like the rationals -- we do not need to perform arbitrary arithmetic operations on them. For example, we do not strictly require addition or multiplication for our purpose.
We thus implement only the bare minimum of functionality here, mostly consisting of the following operations:
ordering two real algebraic numbers, evaluating constraints over a model with real algebraic numbers, and isolating the real roots of a multivariate polynomial over a (partial) model.
In addition, we present a few more elementary operations, required for the above.

Our implementation follows a few guiding principles that are by no means unique or particularly ingenious, but we feel are worth noting.
If we can infer the result from the numerical information alone -- for example for ordering two real algebraic numbers -- doing so is usually way more efficient than considering the algebraic information.
Furthermore, we oftentimes \emph{refine} a real algebraic number -- usually by making the isolating interval smaller, but possibly also reducing the polynomial if it is not a minimal polynomial already -- and we ``propagate'' this refinement to all instances of this particular real algebraic number by maintaining a \emph{common global state}.

\paragraph{Refinement.}\label{preliminaries:ran:refinement}\silentdefindex{ran:refinement}
The refinement of a real algebraic number $\alpha$ aims at making the isolating interval smaller but still having it isolate the same real root.
The easiest strategy is to split the interval in half, check whether the root is in the left part or the right part of the interval, and replace the interval by its left or right half accordingly. To check whether a particular interval contains a root we can employ methods like Sturm's theorem~\cite{Sturm1829} or Descartes' rule of sign~\cite{Descartes1637,Collins1976} that we also use for real root isolation as discussed in \cref{ssec:preliminaries:ran:real-root-isolation}.

If we can ensure that the polynomial is square-free -- for example because it is a minimal polynomial -- we can improve upon this by only considering the sign of the polynomial at the interval endpoints.
We can then establish the invariant that the signs of the endpoints of any isolating interval are different and use this criterion to select the new isolating interval. We formalize this observation in the following \cref{thm:ran:refinement-square-free}.

\begin{theorem}{Refinement with irreducible polynomials}{ran:refinement-square-free}
	Let $p \neq 0$ be an \emph{irreducible} polynomial (for example a minimal polynomial) and $(\BoundL{\alpha}, \BoundU{\alpha})$ an isolating interval for some real root of $p$.
	Then $\sgn(p(\BoundL{\alpha})) \neq \sgn(p(\BoundU{\alpha}))$.
	Let now $c \in (\BoundL{\alpha}, \BoundU{\alpha})$ be a \emph{pivot point}. Then a new isolating interval is
	\begin{align*}
		(\BoundL{\alpha}, c) & \textrm{ if } \sgn(p(c)) = \sgn(p(\BoundU{\alpha})) \\
		[c,c] & \textrm{ if } p(c) = 0 \\
		(c, \BoundU{\alpha}) & \textrm{ if } \sgn(p(c)) = \sgn(p(\BoundL{\alpha}))
	\end{align*}
\end{theorem}
\begin{proof}
	Let $p'$ be the derivative of $p$.
	As $p \neq 0$ is irreducible and $p \neq p'$ due to $\Degree(p') < \Degree(p)$, we know that $p$ and $p'$ have no common roots and thus $p'(\alpha) \neq 0$ for every real root $\alpha$ of $p$. Therefore, the signs of $\lim\limits_{x \uparrow \alpha}{p(x)}$ and $\lim\limits_{x \downarrow \alpha}{p(x)}$ are different and thus an infinitesimally small interval around $\alpha$ is isolating with the above property.

	Now assume that $(\BoundL{\alpha}, \BoundU{\alpha})$ is an isolating interval.
	Due to the observation that the upper and lower limits have different signs, we also know that $p(\BoundL{\alpha})$ and $p(\BoundU{\alpha})$ have different signs. Otherwise, $p$ would need to have another root in the interval -- to change from one sign at $\BoundL{\alpha}$ ($\BoundU{\alpha}$) to the other sign at the lower (upper) limit -- according to the intermediate value theorem. The existence of this other root, however, contradicts the assumption that the interval was isolating.

	Given that the endpoints of any isolating interval have different signs (and the interval contains only a single root) the only sign change occurs exactly at the real root. We can thus refine the interval by selecting an arbitrary new interval contained in the isolating interval which still contains this single sign change.
\end{proof}

It can be useful to not select the \emph{pivot point} arbitrarily ``at random''.
If we refine the representations of $\alpha_1$ and $\alpha_2$ to establish that $\alpha_1 \neq \alpha_2$ by showing that $I_1$ and $I_2$ are disjoint, we can use $\BoundL{\alpha}_2$ (or $\BoundU{\alpha}_2$) as pivot points.
If $I_1$ is refined to be below $\BoundL{\alpha}_2$ (or above $\BoundU{\alpha}_2$) we obtain the result after a single refinement step.

\paragraph{Comparison.}\label{pre:ran:comparison}\silentdefindex{ran:comparison}
Comparing two real algebraic numbers is the evaluation of the common relational operators -- $<, \leq, =, \neq, \geq, >$ -- in line with the standard relation on real numbers.
This allows us to recognize that two real algebraic numbers are, in fact, equal -- even if their representation is not identical -- or sort a list of real algebraic numbers.
In many cases, a reasonably good numeric approximation (from the interval $I$) is sufficient for comparison. If we assume the real algebraic numbers to be \emph{different}, we can refine the numeric approximations until the intervals are disjoint.

Let us thus consider the question whether two real algebraic numbers $\alpha_1 = (p_1, I_1)$ and $\alpha_2 = (p_2, I_2)$ are equal.
Recall that we did not assume the polynomial to be the minimal polynomial, hence $\alpha_1$ and $\alpha_2$ might be equal although $p_1 \neq p_2$.
Still, $\alpha_1 = \alpha_2$ implies that $p_1$ and $p_2$ have a common root, or equivalently that they are a root of $\gcd(p_1, p_2)$.
We can thus compute the greatest common divisor and use the result to refine $\alpha_1$ and $\alpha_2$ as shown in \cref{algo:ran:refine-with-gcd}.
If we always use minimal polynomials, $p_1 \neq p_2$ directly implies $\alpha_1 \neq \alpha_2$ and this refinement is not only unnecessary but also completely pointless: if $p_1$ and $p_2$ are both minimal polynomials, they are either identical or their greatest common divisor is one and no refinement can be done.

\begin{algorithm}[ht]
	\caption{Refine polynomial of two real algebraic numbers}\label{algo:ran:refine-with-gcd}
	\SetKwFunction{RefinePolynomial}{RefinePolynomial}
	\Fn{\RefinePolynomial{$\alpha_1$, $\alpha_2$}}{
		$g \coloneqq \gcd(p_1, p_2)$ \;
		\If{$\alpha_1$ is a root of $g$}{
			$p_1 \coloneqq g$
		}
		\Else{
			$p_1 \coloneqq p_1 / g$
		}
	}
\end{algorithm}

This algorithm relies on being able to decide whether the real algebraic number $\alpha_1$ is a root of the polynomial $g$. Though this is a more difficult question in general, we have that $g$ is a factor of $p_1$ here which makes it significantly easier to answer: we have that $\Roots(g) \subseteq \Roots(p_1)$ and hence the isolating interval of $\alpha_1$ either isolates a single or no root of $g$. Thus we only need to check whether $g$ has a root in $I_1$ which can be done by Descartes' rule of signs, or any other method mentioned in \cref{ssec:preliminaries:ran:real-root-isolation}.

After this refinement -- or without it, if we use minimal polynomials anyway -- we check whether $p_1 \neq p_2$. If so, we immediately have $\alpha_1 \neq \alpha_2$, otherwise we need to refine the intervals until they are either disjoint (certifying $\alpha_1 \neq \alpha_2$) or one of the intervals contains the other (implying $\alpha_1 = \alpha_2$).

\paragraph{Sampling.}\silentdefindex{ran:sampling}
An important part of many procedures that are presented later is to generate a sample point $s$ relative to one or two real algebraic numbers. We generally distinguish the following three cases:
\begin{align*}
	s &< \alpha & s &\in (\alpha_1,\alpha_2) & \alpha &< s
\end{align*}
Assuming that $\alpha_1 < \alpha_2$, a sufficiently good numeric approximation (such that $\BoundU{\alpha}_1 < \BoundL{\alpha}_2$) is enough to generate a rational sample point $s$ in all cases.
We can then implement sampling as follows:
\begin{align*}
	\textrm{for } s < \alpha: \quad & s = \BoundL{\alpha} - 1 \\
	\textrm{for } s \in (\alpha_1,\alpha_2): \quad & s = midpoint(\BoundU{\alpha}_1, \BoundL{\alpha}_2) \\
	\textrm{for } \alpha < s: \quad & s = \BoundU{\alpha} + 1
\end{align*}

\paragraph{Evaluation of constraints.}
Given that we want to find a solution to systems of constraints, we need to be able to evaluate constraints -- or, in other words, evaluate the sign of a polynomial for some model. To simplify the later presentation, we define the exact problem in \cref{def:ran:evaluation}.

\begin{definition}{Evaluation over real algebraic numbers}{ran:evaluation}\silentdefindex{ran:evaluation}
	Let $p \sim 0$ be a constraint and a model $\A$ that may contain real algebraic numbers. We denote the question whether $p \sim 0$ is true after substituting $\A$ into $p$ by \emph{evaluating $p \sim 0$} or equivalently \emph{determining the sign of $p$}.
\end{definition}

As before, a good numeric approximation can be very beneficial in practice.
Let us assume that the polynomial $p$ evaluates to some value that is different from zero. In this case, we can employ interval arithmetic to evaluate $p$ over the isolating intervals from $\A$ and refine these isolating intervals until the result of the evaluation (by interval arithmetic) no longer contains zero. We can then safely derive the sign of $p$ under $\A$.
However, we need to stop this method eventually in case $p$ evaluates to zero to ensure termination.

One possible approach -- which is the one we implement -- is to construct the polynomial $q \coloneqq \xi - p$ and isolate the real roots in $\xi$. For several reasons -- in particular because $q$ is linear in $\xi$ -- this is much easier than the general \emph{multivariate real root isolation} we discuss in the subsequent section: 
\begin{enumerate*}
	\item we know that we are only looking for a single real root $\alpha$,
	\item we know that we can obtain an interval $I$ that contains $\alpha$ by evaluating $p$ over the isolating intervals from $\A$,
	\item we only need to determine the sign of $\alpha$.
\end{enumerate*}

Our method furthermore relies on the fact that we can use any of the bounds on real roots from \cref{ssec:preliminaries:ran:real-root-isolation} to obtain a \emph{lower bound $lb$} on positive real roots (and accordingly \emph{upper bound $ub$} on negative real roots).
From these roots, we can derive
\begin{enumerate*}
	\item if $I \subseteq (-\infty,0)$ then $\alpha < 0$,
	\item if $I \subseteq (ub, lb)$ then $\alpha = 0$,
	\item if $I \subseteq (0, \infty)$ then $\alpha > 0$.
\end{enumerate*}
Given these observations, we only need to refine the real algebraic numbers in $\A$ until $I$ satisfies one of these criteria.

The careful reader might notice that the bounds on real roots from \cref{ssec:preliminaries:ran:real-root-isolation} are defined for univariate polynomial over number coefficients while $q$ is a multivariate polynomial.
We thus need to ``eliminate'' all variables (except $\xi$) from $q$ and do so as described in \cref{def:ran:task-evaluation} to compute bounds on the real roots.
Furthermore, note that although we initially described our approach as isolating the real roots of $\xi - p$ in $\xi$, we have not used this more general approach here but rather use a more specialized method that exploits the additional knowledge mentioned above.

We have seen that the partial evaluation of $q$ that we use to compute the bounds on real roots might introduce what we called \emph{spurious roots}. They do not pose a serious problem here as they might only make the bounds worse and we thus simply ignore this issue here.

\paragraph{Multivariate real root isolation}\silentdefindex{ran:real-root-isolation}

Finally, we need to compute the real roots of a polynomial over a given model $\A$. More specifically, we have a multivariate polynomial $p \in \Q[x_1, \dots, x_k]$ and $\A = \{ x_1 \mapsto \alpha_1, \dots x_{k-1} \mapsto \alpha_{k-1} \}$ and want to compute all real roots of the univariate polynomial that is created by substituting the model into $p$. As noted above, we can not simply substitute the model into $p$ and invoke a method for real root isolation -- at least not in every case -- but need to employ some other method.

As before, we employ the (partial) evaluation of $p$ over $\A$ to obtain a polynomial $q$ that covers the roots of $p$.
Multivariate root isolation is thus implemented as
\begin{enumerate*}
	\item partially evaluating $p$ in the sense of \cref{def:ran:task-evaluation}, obtaining $q$,
	\item isolating the (univariate) real roots $\alpha_i$ of $q$, and
	\item removing spurious roots where $p$ does not vanish at $\A \cup \{ x_k \mapsto \alpha_i \}$ by evaluating the constraint $p = 0$.
\end{enumerate*}

As already explained and shown in \cref{ex:algebraic-substitution-with-spurious-roots}, the result of the partial evaluation can have spurious roots where $p$ in fact does not vanish.
Note that we thus require evaluating the constraint $p = 0$ in the third step.
Therefore, it is crucial that we implement this constraint evaluation from the previous section without actually relying on multivariate root isolation to avoid cyclic dependencies.

\subsection{Other representations}\label{ssec:preliminaries:ran:other-representations}

As already mentioned, other representations for real algebraic numbers exist.
We now briefly describe two alternatives based on root indexing and employing Thom's lemma to get a unique characterization of roots.
Be aware that using different representations within one implementation usually has the significant caveat that they do not interact nicely. We assume that our whole software uses either of them and all real algebraic numbers that we have -- in one execution of our program -- have the same representation.

Of course, a rational root can be represented as a rational number and we convert all of the representations to a simple rational representation if possible. All described algorithms gracefully integrate rational representations, thus being an exception to the above restriction.

\paragraph{Indexed representation.}\silentdefindex{ran:repr-indexed}
Instead of storing an isolating interval, we can also identify a root by its index among all the (ordered) real roots of the given polynomial.
This makes for a very concise representation and also allows for some computations.
However, we eventually need some numeric representation -- usually intervals -- for many operations.

Note that this indexed representation can nicely be generalized to higher dimensions to what we call \emph{multivariate roots} in \cref{sec:mcsat:explanations} where we identify a root of a multivariate polynomial over a partial model (that assigns all but one particular variable).

\paragraph{Thom representation.}\silentdefindex{ran:repr-thom}
Another representation based on Thom's lemma consists of \emph{sign conditions on the derivatives} of a polynomial and is sometimes called \emph{Thom encoding}.
They offer a very different approach to represent real algebraic numbers and a thorough definition can be found in~\cite{Basu2010} which also proposes a variant of CAD based on Thom encodings.

We have experimented with Thom encodings and found them to be surprisingly efficient but still not on par with the interval-based representation shown before.
Details on our implementation, as well as some experiments, can be found in~\cite{Winkler2016}.
Note, however, that some issues with our implementation are listed at the end of~\cite{Winkler2016}, thus its performance relative to the interval-based representation could probably be improved.